<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: workgroup.php,v 1.12 2003/09/03 15:18:50 vollmerk Exp $
 $Source: /a1/cvsroot/maint/modules/class/workgroup.php,v $

 The workgroup class definition that describes workgroup information
   for given hosts.  Each host has a workgroup definition associated with
   it and it allows us to set per-host DHCP options as well as dynamic
   VLAN settings.

*/

class Workgroup {
	var $id;

	var $name;
	var $original_name;
	var $zone; // just the ID

	// these are Subnet & VLAN objects
	var $subnet;
	var $vlan;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Workgroup( $workgroup_id ) {
		global $conf;

		$this->id = $workgroup_id;
		$info = $this->get_info();

		if ( ! $info ) {
			return false;
		}

		$this->name		= $info->name;
		$this->original_name	= $info->original_name;
		$this->zone		= $info->zone;
		$this->subnet		= new Subnet($info->subnet);
		$this->vlan		= new VLAN($info->vlan);
	} // Workgroup

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM workgroup WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);
	} // get_info

        /*!
                @function get_options
                @discussion get the local options for this object assumes $this
        */
        function get_options() {
                global $conf;

                $sql = "SELECT * FROM workgroup_option_local WHERE workgroup=$this->id";
                $db_result = mysql_query($sql, $conf['dbh']);

                while ( $obj = mysql_fetch_object($db_result) ) {
                        $options[] = new Option($obj->id, 'workgroup');
                }

                return $options;

        } // get_options

	// get the ranges that this workgroup is allowed to be used in
	function get_ranges() {
                global $conf;

		if (!$this->subnet->id) { return array(); }

                $sql = "SELECT id FROM ranges WHERE subnet=". $this->subnet->id;
                $db_result = mysql_query($sql, $conf['dbh']);

		$ranges = array();
		
		while ($range = mysql_fetch_object($db_result) ) {
			$ranges[] = new Range($range->id);	
		}

		return $ranges;
        } // get_ranges

	/*!
		@function get_zones
		@discussion gets all the zones that are mapped to this workgroup
	*/
	function get_zones() {
		global $conf;

		$sql = "SELECT zone FROM zone_workgroup WHERE zone_workgroup.workgroup='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) { 
			$results[] = new Zone($r->zone);
		}


		return $results;


	} // get_zones

	/*!
		@function delete_zone
		@discussion deletes a zone_workgroup mapping for this workgroup
	*/
	function delete_zone($zone_id) {
		global $conf;

		$sql = "DELETE FROM zone_workgroup WHERE zone='$zone_id' AND workgroup='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

	} // delete_zone

	/*!
		@function add_zone
		@discussion adds a zone_workgroup mapping for this workgroup
	*/
	function add_zone($zone_id,$default) { 
		global $conf;

		// Check to make sure it isn't in there already...
		$sql = "SELECT id FROM zone_workgroup WHERE workgroup='$this->id' AND zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if (mysql_fetch_array($db_results)) { return false; }

		else {
			if (!$default) { $default = false; }
			$sql = "INSERT INTO zone_workgroup (zone,workgroup,is_default) VALUES ('$zone_id','$this->id','$default')";
			$db_results = mysql_query($sql, $conf['dbh']);
		}

		return true;		

	} // add_zone

	/*!
		@function is_default
		@discussion return true if the workgroup is considered a default workgroup 
			for the specified zone
	*/
	function is_default($zone_id) { 
		global $conf;

		$sql = "SELECT is_default FROM zone_workgroup WHERE zone='$zone_id' AND workgroup='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_array($db_results);

		return $results[0];

	} // is_default

	/*!
		@function make_default
		@discussion makes this workgroup default for the specified zone
	*/
	function make_default($zone_id,$default) {
		global $conf;

		$sql = "UPDATE zone_workgroup SET is_default='$default' WHERE workgroup='$this->id' AND zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);


	} // make_default

	// the update functions... there are a bunch of them
        function update_name ($new_name) {
                $this->update_item('name', $new_name);
                $this->name = $new_name;
        } // update_name

	function update_original_name ($new_name) {
                $this->update_item('original_name', $new_name);
                $this->original_name = $new_name;
        } // update_original_name

	function update_subnet ($subnet) {
                $this->update_item('subnet', $subnet);
                $this->subnet = $subnet;
        } // update_subnet

	function update_vlan($vlan) {
                $this->update_item('vlan', $vlan);
                $this->vlan = $vlan;
        } // update_vlan

	function update_zone($zone) {
		$this->update_item('zone', $zone);
		$this->zone= $zone;
	}

        function update_item($type, $new_item) {
                global $conf;

                $sql = "UPDATE workgroup SET $type='$new_item' WHERE id='$this->id'";
                $db_results = mysql_query($sql, $conf['dbh']);
        } // update_item

}

?>
